import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.net.URL;
import java.util.List;
/**
 * Write a description of class NewAccountMenu here.
 * 
 * @author Anthony Hoang
 * @version (v1)
 */
public class LoadGame extends Menu
{
    private int WIDTH = 175;
    private int HEIGHT= 50;
    private GreenfootImage image;
    private GreenfootImage image2;
    private String user;
    private String pass;
    private boolean firstInitialize = true;
    public LoadGame()
    {
        image = new GreenfootImage(WIDTH, HEIGHT);
        image2 = new GreenfootImage(WIDTH, HEIGHT);
        drawOne();
        image.setTransparency(0);
        image2.setTransparency(0);
        setImage(image2);
    }
    public void act() 
    {
        if (firstInitialize)
        {
            int t = getImage().getTransparency()+5;
            if (t > 255)
            firstInitialize = false;
            else
            {
                image.setTransparency(t);
                image2.setTransparency(t);
            }
        }
        if (closing)
        {
            int t = getImage().getTransparency()-10;
            if (t < 0)
            getMWorld().removeObject(this);
            else
            {
                image.setTransparency(t);
                image2.setTransparency(t);
            }
            return;
        }
        if (mouseOverThis() )
        {
            if (getImage().equals(image2))
            setImage(image);
        }
        else 
        if (getImage().equals(image))
        setImage(image2);
        if (Greenfoot.mouseClicked(this))
        {
            List<Typer> list = getMWorld().getObjects(Typer.class);
            if (list.size() == 0)
            {
                getMWorld().addObject(new TyperBackground(), 440, 247);
                getMWorld().addQWERTYKeys();
                getMWorld().addObject(new KeyMenuReturn(), 769, 466);
                getMWorld().addObject(new Typer(), 440, 247);
            }
        }
        List<Typer> list = getMWorld().getObjects(Typer.class);
        if (list.size() != 0)
        {
            Typer typer = list.get(0);
            if (typer.hasEnter)
            {
                String str = "data/eventscript/svg/"+typer.getString()+".txt";
                URL url = getClass().getClassLoader().getResource(str);
                if(url == null)
                {
                    List list2 = getMWorld().getObjects(SystemMessage.class);
                    //if (list.size()<= 0)
                    getMWorld().addSystemMessage("incorrectLoadGame.txt");
                    typer.hasEnter = false;
                }
                else
                {
                    getMWorld().removeObjects(getMWorld().getObjects(EventScript.class));
                    getMWorld().eventCount = 0;
                    str = "svg/"+typer.getString();
                    getMWorld().removeObject(typer);
                    getMWorld().removeObjects(getMWorld().getObjects(ReturnToGame.class));
                    getMWorld().addEventScript("removeMenu");
                    getMWorld().addEventScript(str);
                    getMWorld().gamePause = false;
                }
            }
        }
    }    
    public void drawOne()
    {
        image.setColor(Color.GRAY);
        image.fill();
        image.setColor(new Color(5, 5, 75 ,150));
        image.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        Font font = image.getFont();
        font = font.deriveFont(25f);
        image.setFont(font);
        image.setColor(Color.WHITE);
        image.drawString("Load Game", 19, 32);
        image2.setColor(new Color(5, 5, 50 ,150));
        image2.fillRect(5, 5, WIDTH-10, HEIGHT-10);
        font = image.getFont();
        font = font.deriveFont(25f);
        image2.setFont(font);
        image2.setColor(Color.WHITE);
        image2.drawString("Load Game", 19, 32);
    }
}
