import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class CleanBlue here.
 * 
 * @author Anthony Hoang
 * @version (v1)
 */
public class MenuProjectileGray extends MenuObjects
{
    private static GreenfootImage img;
    private Vector v = new Vector();
    private double x=0, y=0;
    private int x2,y2;
    private boolean firstInitialize = true;
    private int r;
    private int checkDelay = 0;
    public MenuProjectileGray()
    {
        if (img == null)
        {img = new GreenfootImage("grayDust.png");
        img.scale(img.getWidth()/2, img.getHeight()/2);}
        setImage(new GreenfootImage(img));
    }
    public void act() 
    {
        if (closing)
        {
            getMWorld().removeObject(this);
            return;
        }
        if (firstInitialize)
        {
            x = getX();
            y = getY();
            firstInitialize = false;
        }
        else
        move();
    }    
    public void explode()
    {
        for (int i = 0; i < 10; i++)
        getMWorld().addObject(new DustParticle((int)(Math.random()*360)),getX(),getY());

        int w = getImage().getWidth();
        int h = getImage().getHeight();
        if (w <= 5 || h <= 5)
        getMWorld().removeObject(this);
        else
        getImage().scale(w-5, h-5);
    }
    public void move()
    {
        List<Actor> a = getMWorld().getObjects(MenuTarget.class);
        if (a.size()!=0)
        {
            Actor actor = a.get(0);
            if (actor != null)
            {
                r = getAngleTo(actor.getX(), actor.getY());
                getMWorld().addObject(new DustParticle(r),getX(),getY());
                v.add(new Vector(r, Math.random()*.5 ));
                setRotation(r);
                x+=v.getX();
                y+=v.getY();
                if (x > getWorld().getWidth()) x = getWorld().getWidth();
                if (x < 0) x = 0;
                if (y > getWorld().getHeight()) y = getWorld().getHeight();
                if (y < 0) y = 0;
            }
        }
        setLocation((int)x,(int)y);
    }
    private int getAngleTo(double x2, double y2)
    {
        double deltaX = x2 - x;
        double deltaY = y2 - y;
        return (int)(180 * Math.atan2(deltaY, deltaX) / Math.PI);
    }
}
