import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Standard helperbot attacks any ingamehostile
 * in range.
 * it animates itself too.
 * 
 * @author Anthony Hoang
 * @version (v1)
 */
public class StandardHelperBot  extends HelperBot
{
    private static GreenfootImage[] img;
    private int delay = 0;
    private int attackDelay = 50;
    private int range = 200;
    public StandardHelperBot()
    {   
        super(true);
        if (img == null)
        {
            img = new GreenfootImage[3];
            img[0] = new GreenfootImage("helperbot/helperbot.png");
            img[1] = new GreenfootImage("helperbot/helperbot_2.png");
            img[2] = new GreenfootImage("helperbot/helperbot_3.png");
        }
        setImage(img[0]);
        attackDelay = (int)(attackDelay*Math.random())+30;
    }
    public StandardHelperBot(int r)
    {
        this();
        range = r;
    }
    public StandardHelperBot(int r, boolean follow)
    {
        super(follow);
        if (img == null)
        {
            img = new GreenfootImage[3];
            img[0] = new GreenfootImage("helperbot/helperbot.png");
            img[1] = new GreenfootImage("helperbot/helperbot_2.png");
            img[2] = new GreenfootImage("helperbot/helperbot_3.png");
        }
        setImage(img[0]);
        attackDelay = (int)(attackDelay*Math.random())+30;
        range = r;
    }
    public void setImage()
    {
        if (getImage().equals(img[0]))
        setImage(img[1]);
        else if (getImage().equals(img[1]))
        setImage(img[2]);
        else setImage(img[0]);
    }
    public void act() 
    {
        if (getMWorld().esPause) return;
        if (delay == 0)
        {
            setImage();
            delay = 5;
        }
        delay--;
        if (attackDelay < 0 && !hasHit)
        {
            attack();
            attackDelay = 50;
        }
        else
        attackDelay--;
        super.act();
    }    
    
    public void attack()
    {
        List<InGameHostile> l1 = getObjectsInRange(range,InGameHostile.class);
        if (l1.size()!=0)
        {
            Greenfoot.playSound("cleanbotfire.wav");
            getMWorld().addObject(new CleanBlue(),getX(),getY());
        }
    }
}
