import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
public class Typer extends Menu
{
    private String str = "";
    private GreenfootImage img;
    private boolean firstInitialize = true;
    public boolean hasEnter = false;
    private boolean redraw = false;
    private int typeDelay = 10;
    public Typer()
    {
        img = new GreenfootImage(500, 50);
        img.setTransparency(0);
        drawTyper();
    }
    public void act()
    {
        if (firstInitialize)
        {
            int t = getImage().getTransparency()+15;
            if (t > 255)
            firstInitialize = false;
            else
            getImage().setTransparency(t);
        }
        if (closing)
        {
            int t = getImage().getTransparency()-10;
            if (t < 0)
            getMWorld().removeObject(this);
            else
            getImage().setTransparency(t);
            return;
        }
        if (typeDelay == 0)
        {
            doType();
        }
        if (typeDelay > 0)
        typeDelay--;
        if (redraw)
        drawTyper();
    }
    public void close()
    {
        closing = true;
    }
    public void drawTyper()
    {
        img.clear();
        img.setColor(new Color(5, 5, 50 ,150));
        img.fill();
        img.setColor(Color.BLUE);
        img.drawRect(10, 10, img.getWidth()-20, img.getHeight()-20);
        img.setColor(Color.WHITE);    
        Font font = img.getFont().deriveFont(30f);
        img.setFont(font);
        img.drawString(str, 25, 35);
        setImage(img);
    }
    public void doType()
    {
        if (Greenfoot.isKeyDown("backspace") && str.length() > 0)
        {
            str = str.substring(0, str.length()-1);
            typeDelay = 9;
        }
        
       if (Greenfoot.isKeyDown("enter"))
       {
           hasEnter = true;
           typeDelay = 10;
           return;
       }
       
       if (str.length() > 20)
       {
           if (getObjectsInRange(500, SystemMessage.class).size()>0)
           getMWorld().addSystemMessage("textTooLong.txt");
           str = str.substring(0,str.length()-1);
           return;
       }
       if (Greenfoot.isKeyDown("space"))
       {
           str += " ";
           typeDelay = 10;
        }
    }
    public String getString()
    {
        return str;
    }
    public void setString(String s)
    {
        if (s.length() > 20)
        {
            if (getMWorld().getObjects(SystemMessage.class).size() == 0)
            getMWorld().addSystemMessage("textTooLong.txt");
        }
        else
        str = s;
        redraw = true;
    }
    public Midori getMWorld()
    {
        return (Midori) getWorld();
    }
}