import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Write a description of class UpDownPlatform here.
 * 
 * @author Anthony Hoang
 * @version v1
 */
public class UpDownPlatform  extends Platform
{
    private int speed;
    private boolean up = false;
    private boolean charWasAbove = false;
    public UpDownPlatform(int s, int width)
    {
        super();
        setImage(new GreenfootImage(platform1));
        getImage().scale(width, getImage().getHeight());
        speed = s;
    }
    public void act() 
    {
        if (getMWorld().esPause) return;
        charWasAbove = isAbove();
        move();
        if (charWasAbove)
        moveChar();
    }    
    public void move()
    {
        if (up)
        {
            if (!blackBetweenY(getY()-getImage().getHeight()*10-speed))
            setLocation(getX(), getY()-speed);
            else
            {
                up = false;
                Greenfoot.playSound("platformhit.wav");
            }
        }
        else
        {
            if (!blackBetweenY(getY()+getImage().getHeight()/2+speed))
            setLocation(getX(), getY()+speed);
            else
            {
                up = true;
                Greenfoot.playSound("platformhit.wav");
            }
        }
    }
    public void moveChar()
    {
        Actor a = getOneIntersectingObject(InGameCharacter.class);
        if (a != null) 
        {
            int t = getY();
            if (!up)
            t+=speed;
            a.setLocation( a.getX(), t-getImage().getHeight()/2-a.getImage().getHeight()/2);
        }
    }
}
